import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;



public class InputFrame extends JFrame {
	
	private JPanel panel;
	private JPanel commonPanel;
	private JPanel carHousePanel;
	private JPanel carPanel;
	private JPanel housePanel;
	private JLabel commonLabel;
	private JLabel carLabel;
	private JLabel houseLabel;
	private JTextField nameField;
	private JTextField durationField;
	private JTextField displacementField;
	private JTextField squareMetersField;
	private JButton storeCarButton;
	private JButton storeHouseButton;
	private ArrayList<Insurance> insurances;
	
	public InputFrame(ArrayList<Insurance> insurances) {
		
		this.insurances = insurances;
		
		panel = new JPanel();
		commonPanel = new JPanel();
		carPanel = new JPanel();
		housePanel = new JPanel();
		carHousePanel = new JPanel();
		
		panel.setLayout(new GridLayout(2, 0));
		
		commonLabel = new JLabel("Autokinita kai Spitia");
		carLabel = new JLabel("Autokinita");
		houseLabel = new JLabel("Spitia");
		
		nameField = new JTextField("Onoma");
		durationField = new JTextField("Diarkeia se mines");
		displacementField = new JTextField("Kyvika Ekatosta");
		squareMetersField = new JTextField("Tetragwnika Metra");
		
		storeCarButton = new JButton("Apothikeusi");
		storeHouseButton = new JButton("Apothikeusi");
		
		commonPanel.setLayout(new GridLayout(3, 0));
		commonPanel.add(commonLabel);
		commonPanel.add(nameField);
		commonPanel.add(durationField);
		commonPanel.setBorder(BorderFactory.createLineBorder(Color.black));
		
		carPanel.setLayout(new GridLayout(3, 0));
		carPanel.add(carLabel);
		carPanel.add(displacementField);
		carPanel.add(storeCarButton);
		carPanel.setBorder(BorderFactory.createLineBorder(Color.black));
		
		housePanel.setLayout(new GridLayout(3, 0));
		housePanel.add(houseLabel);
		housePanel.add(squareMetersField);
		housePanel.add(storeHouseButton);
		housePanel.setBorder(BorderFactory.createLineBorder(Color.black));
		
		carHousePanel.add(carPanel);
		carHousePanel.add(housePanel);
		
		panel.add(commonPanel);
		panel.add(carHousePanel);
		
		this.setContentPane(panel);
		
		ButtonListener listener = new ButtonListener();
		storeCarButton.addActionListener(listener);
		storeHouseButton.addActionListener(listener);
		
		this.setVisible(true);
		this.setSize(300, 300);
		this.setLocation(0, 0);
		this.setTitle("Input");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	class ButtonListener implements ActionListener {
		
		public void actionPerformed(ActionEvent e) {
			
			String name = nameField.getText();
			boolean flag = false;
			
			for(Insurance i : insurances) {
				if(name.equals(i.getName())) {
					System.out.println("Name Already exists");
					flag = true;
					break;
				}
			}
			
			if(flag == false) {
			
				String durationText = durationField.getText();
				int duration = Integer.parseInt(durationText);
				
				if(e.getSource().equals(storeCarButton)) {
					int displacement = Integer.parseInt(displacementField.getText());
					insurances.add(new CarInsurance(name, duration, displacement));
				}
				else {
					int squareMeters = Integer.parseInt(squareMetersField.getText());
					insurances.add(new HouseInsurance(name, duration, squareMeters));
				}
			
			}
			
		}
		
		
	}

}
